<?php
if(!class_exists('WP_List_Table'))
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
	
class fbdeWINC_admin_display extends WP_List_Table
{
	private $values;
	
	function __construct()
	{
        global $status, $page;
                
        //Set parent defaults
        parent::__construct( array(
            'singular'  => 'Element',     //singular name of the listed records
            'plural'    => 'Elemente',    //plural name of the listed records
            'ajax'      => false        //does this table support ajax?
        ) );
        
    }

	function set_values($values_in)
	{
		$this->values = $values_in;
	}
	
    function column_default($item, $column_name)
	{
        switch($column_name){
            case 'url':
            case 'key':
                return $item[$column_name];
            default:
                return print_r($item,true); //Show the whole array for troubleshooting purposes
        }
    }
    
    function column_url($item)
	{
		//Build row actions
        $actions = array(
			/*
			*********************************
			*	Editfunktion hinzufügen		*
			*********************************
			*/
           // 'edit'      => sprintf('<a href="?page=%s&action=%s&element=%s">Edit</a>',$_REQUEST['page'],'edit',$item['ID']),
            'delete'    => sprintf('<a href="?page=%s&action=%s&element=%s">Delete</a>',$_REQUEST['page'],'delete',$item['ID']),
        );
        
        //Return the title contents
        return sprintf('%1$s %2$s',
            /*$1%s*/ $item['url'],
            /*$2%s*/ $this->row_actions($actions)
        );
    }

    function get_columns()
	{
        $columns = array(
            'url'     => 'URL',
            'key'    => 'API-Schlüssel'
        );
        return $columns;
    }

    function get_sortable_columns() 
	{
        $sortable_columns = array('url' => array('url',true));     //true means it's already sorted
        return $sortable_columns;
    }
    
    
    /** ************************************************************************
     * Optional. If you need to include bulk actions in your list table, this is
     * the place to define them. Bulk actions are an associative array in the format
     * 'slug'=>'Visible Title'
     * 
     * If this method returns an empty value, no bulk action will be rendered. If
     * you specify any bulk actions, the bulk actions box will be rendered with
     * the table automatically on display().
     * 
     * Also note that list tables are not automatically wrapped in <form> elements,
     * so you will need to create those manually in order for bulk actions to function.
     * 
     * @return array An associative array containing all the bulk actions: 'slugs'=>'Visible Titles'
     **************************************************************************/
    function get_bulk_actions() 
	{
		$actions = array();
		return $actions;
    }
    
    
    /** ************************************************************************
     * Optional. You can handle your bulk actions anywhere or anyhow you prefer.
     * For this example package, we will handle it in the class to keep things
     * clean and organized.
     * 
     * @see $this->prepare_items()
     **************************************************************************/
    function process_bulk_action() 
	{
		if(isset($_GET['element']) && ctype_digit($_GET['element']))
		{
			$element = $_GET['element'];
			//Detect when a bulk action is being triggered...
			switch($this->current_action())
			{
			case 'delete':
				$res = false;
				$i = 0;
				$length_data = count($this->values);
				while ($res === false && $i < $length_data)
				{
					if (intval($this->values[$i]['ID']) === intval($element))
					{
						$deleter = $this->values[$i];
						$res = true;
					}
					$i++;
				}
				$temp = array_search($deleter, $this->values);
				if ($temp !== false)
				{
					unset($this->values[$temp]);
					$this->values = array_values($this->values);
					update_option('fbdeWINC_data', $this->values);
				}
				break;
			case 'edit':
				/*
				*********************************
				*	Editfunktion hinzufügen		*
				*********************************
				*/
				break;
			}
		}		
    }

    function prepare_items() 
	{
        $per_page = 5;
		$this->process_bulk_action();
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();

        $this->_column_headers = array($columns, $hidden, $sortable);

        function usort_reorder($a,$b)
		{
            $orderby = (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'url'; //If no sort, default to title
            $order = (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'asc'; //If no order, default to asc
            $result = strcmp($a[$orderby], $b[$orderby]); //Determine sort order
            return ($order==='asc') ? $result : -$result; //Send final sort direction to usort
        }
		if (is_array($this->values))
			usort($this->values, 'usort_reorder');

        $current_page = $this->get_pagenum();

        $total_items = count($this->values);
		if (is_array($this->values))
			$this->values = array_slice($this->values,(($current_page-1)*$per_page),$per_page);

        $this->items = $this->values;

        $this->set_pagination_args( array(
            'total_items' => $total_items,                  //WE have to calculate the total number of items
            'per_page'    => $per_page,                     //WE have to determine how many items to show on a page
            'total_pages' => ceil($total_items/$per_page)   //WE have to calculate the total number of pages
        ) );
    }
}
?>