<?php
/*
Plugin Name: Fussball.de Widget Includer
Plugin URI: http://wordpress.org/plugins/fussballde-widget-includer/
Description: Vereinfachte Benutzung des Fussball.de-Widgets für dein Wordpress!
Version: 0.4
Author: Atlant1s
Author URI: http://profiles.wordpress.org/atlant1s
Min WP Version: 3.5.1
Max WP Version: 3.6
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

class fbdeWINC_main
{
	private static $_this;
	private $values;
	private $key;
	private $wettbewerb;
	private $art;
	private $mandant;

	function __construct() 
	{
		self::$_this = $this;
		$this->values = get_option('fbdeWINC_data');
		
		//register the hooks
		add_action('admin_menu', array($this, 'admin'));
		add_shortcode( 'fbdeWINC_widget', array($this, 'shortcode'));
		register_deactivation_hook(__FILE__, array($this, 'deactivate'));
	}

	static function this() 
	{
		return self::$_this;
	}
	
	function get_values()
	{
		return $this->values;
	}
	
	function set_values($values_in)
	{
		$this->values = $values_in;
	}
	
	function deactivate() 
	{
		//coming soon
	}
	
  	function admin()
	//Create admin-class
	{
		add_option('fbdeWINC_data');
		add_menu_page(__('FWI', 'fwi'), __('FWI', 'fwi'), 'manage_options', __FILE__, array($this, 'admin_page_content'));
	}
	
	function admin_page_content()
	/*
	*	handle and display the content of the admin page
	*/
	{
		
		$val_count = 0;
		$curr_ID = 0;
		
		if (is_array($this->values) && !empty($this->values))
		{
			$val_count = count($this->values);
			$curr_ID = $this->values[$val_count - 1]['ID'] + 1;
		}

		//if the submit button was used, check if the parameter is an hexadecimal number
		if (isset($_POST['submit']) && $_POST['fbdeWINC_key'] != '' && $_POST['fbdeWINC_url'] != '')
		{
			$temp = array('ID' => intval($curr_ID), 'url' => str_replace('http://', '', esc_url_raw($_POST['fbdeWINC_url'])), 'key' => esc_html($_POST['fbdeWINC_key']));
			$this->values[] = $temp;
			update_option('fbdeWINC_data', $this->values);
		}
		
		
		include(plugin_dir_path( __FILE__ ) . 'admin_display.php');
		//Create an instance of our package class...
		$fbdeWINC_admin_display = new fbdeWINC_admin_display();
		$fbdeWINC_admin_display->set_values($this->values);
		//Fetch, prepare, sort, and filter our data...
		$fbdeWINC_admin_display->prepare_items();
		?>
		<div class="wrap nosubsub">
	<h2>Fussball.de Widget Includer</h2>
	<br class="clear" />
	<div class="form-wrap">
		<p><strong>Hinweis:</strong>
		<br />Bei URL bitte genau die gleiche URL angeben wie bei Fussball.de</p>
		<p>Bei Schlüssel wird der von Fussball.de passende Schlüssel eingetragen</p>
		<br />
		<p><strong>Benutzung:</strong>
		<br />Um das Fussball.de-Widget anzuzeigen, bitte folgenden Shortcode verwenden:</p>
		<p>[fbdeWINC_widget show="{Tabelle/Begegnungen}" mandant="{MandantID}" id="{WettbewerbID}"]</p>
	</div>
	<div id="col-container">
		<div id="col-right">
			<div class="col-wrap">
				<form id="movies-filter" method="get">
					<!-- For plugins, we also need to ensure that the form posts back to our current page -->
					<input type="hidden" name="page" value="<?php $_REQUEST['page'] ?>" />
					<!-- Now we can render the completed list table -->
					<?php $fbdeWINC_admin_display->display() ?>
				</form>
			</div><!-- /col-wrap -->
		</div><!-- /col-right -->
		<div id="col-left">
			<div class="col-wrap">
				<div class="form-wrap">
					<h3>Neue URL/Schlüssel eingeben</h3>
					<form name="form1" method="post" action="">
						<label for="fbdeWINC_url">URL</label>
						<input name="fbdeWINC_url" value="" type="text" size="55" maxlength="100" />
						<label for="fbdeWINC_key">Schlüssel</label>
						<input name="fbdeWINC_key" value="" type="text" size="55" maxlength="40" />
						<p class="submit">
							<input type="submit" name="submit" class="button button-primary" value="Hinzufügen" />
						</p>
					</form>
				</div><!-- /form-wrap -->
			</div><!-- /col-wrap -->
		</div><!-- /col-left -->
	</div><!-- /col-container -->
</div><!-- /wrap --><?php
	}
	
	function shortcode($atts)
	/*
	*	accepts this shortcode: // [fbdeWINC_widget show="{$showTypes}" id="{numbers}"]
	*	
	*/
	{
		//define authorizable values for $show
		$showTypes = array('Tabelle', 'Begegnungen');
		
		//default values for the shortcode parameters
		extract(shortcode_atts(array('show' => false, 'mandant' => false, 'id' => false), $atts));
		
		$res = false;
		if(is_array($this->values))
		{
			$count_val = count($this->values);
			$i = 0;
			while (!$res && ($i < $count_val))
			{
				$res = stripos($_SERVER['HTTP_HOST'], $this->values[$i]['url']);
				$i++;
			}
		}

		//let's check, if all variables are got a proper value, else there's no sense in loading the API
		if ($res !== false && $id !== false && $mandant !== false && in_array($show, $showTypes)) 
		{
			$this->wettbewerb = $id;
			$this->art = $show;
			$this->mandant = $mandant;
			$this->key = $this->values[$i - 1]['key'];
			
			//load the Fussball.de API(since it's javascript, let's load it in the footer)
			add_action('wp_footer', array($this, 'add_js_to_footer'));
		}
		
		//return the HTML-code, where we want to display the widget. if this fails, show it to the users
		return '<div id="fbdeWINC_content">Lade Fussball.de-Widget&#8230;</div>';
	}
	
	function add_js_to_footer()
	/*
	*	use the Fussball.de-API and show the widget in the HTML-tag fbdeWINC_content
	*/
	{
		//official documentation of the API:
		//http://www.fussball.de/schluessel-dokumentation/id_41983972/tid_da/index
		echo '
		<script type="text/javascript" src="http://static.fussball.de/fbdeAPI/js/fbdeAPIFunctions.js?schluessel=' . $this->key . '"></script>
		<script type="text/javascript">
			var wettbewerb0 = new fussballdeAPI();
				wettbewerb0.setzeWettbewerb(\'' . $this->wettbewerb . '\');
				wettbewerb0.setzeMandant(\'' . $this->mandant . '\');
				wettbewerb0.zeige' . $this->art . '(\'fbdeWINC_content\');
		</script>';
	}
}
new fbdeWINC_main();
?>